if not _G.Berserker_Help_mod then
	_G.Berserker_Help_mod = _G.Berserker_Help_mod or {}
	Berserker_Help_mod._path = ModPath
	Berserker_Help_mod._data_path = SavePath .. "berserker_live_matters.txt"
	Berserker_Help_mod.available_mult = {"Default", "10%" , "0%"}
	Berserker_Help_mod.available_mult_num = {1,0.1,0.001}
	Berserker_Help_mod._settings = {}
	Berserker_Help_mod._settings["multiplier"] = 1
	Berserker_Help_mod._settings["combat_cancer"] = false
	Berserker_Help_mod._settings.active = 2	
	Berserker_Help_mod._diff_mult_loaded = false
	Berserker_Help_mod._player_damage = nil
end

function Berserker_Help_mod:Set_Player_Damage(plDam)
	Berserker_Help_mod._player_damage = plDam
end

function Berserker_Help_mod:AdjustFixed()
	if Berserker_Help_mod._player_damage then
		if Berserker_Help_mod._settings.fixed and Berserker_Help_mod:AffectedBuild() then
			Berserker_Help_mod._player_damage._max_health_reduction = Berserker_Help_mod.available_mult_num[Berserker_Help_mod._settings.multiplier]
		else
			Berserker_Help_mod._player_damage._max_health_reduction = managers.player:upgrade_value("player", "max_health_reduction", 1)
		end
		Berserker_Help_mod._player_damage._current_max_health = Berserker_Help_mod._player_damage:_max_health() * Berserker_Help_mod._player_damage._max_health_reduction
	end
end


function Berserker_Help_mod:Load()
	local file = io.open(Berserker_Help_mod._data_path, "r")
	if file then
		local decoded = json.decode(file:read("*all")) or {}
		for k, v in pairs(decoded) do
			Berserker_Help_mod._settings[k] = v
		end
		file:close()
	end
end

function Berserker_Help_mod:Save()
	local file = io.open(Berserker_Help_mod._data_path, "w+")
	if file then
		file:write(json.encode(Berserker_Help_mod._settings))
		file:close()
	end
end

function Berserker_Help_mod:AffectedBuild()
	return Berserker_Help_mod:Berserker_Level() >= Berserker_Help_mod._settings.active
end


function Berserker_Help_mod:Berserker_Level()
	if managers.player:has_category_upgrade("player", "damage_health_ratio_multiplier") then
		return 3
	end
	if managers.player:has_category_upgrade("player", "melee_damage_health_ratio_multiplier") then
		return 2
	end
	return 1
end


Hooks:Add("LocalizationManagerPostInit", "Berserker_Help_mod_loc", function(loc)
	LocalizationManager:add_localized_strings({
	["Berserker_Help_mod_main_menu_title"] = "Berserker Live Matters",
	["Berserker_Help_mod_main_menu_desc"] = "Change the health multiplier after revive",
	["Berserker_Help_mod_mult_title"] = "Health Multiplier",
	["Berserker_Help_mod_mult_desc"] = "Health Multiplier after revive",
	["Berserker_Help_mod_combat_cancer_title"] = "Deactivate Combat Medic Ace effect",
	["Berserker_Help_mod_combat_cancer_desc"] = "When ticked combat medic ace will not give you 30% extra health after a revive",
	["Berserker_Help_mod_active_title"] = "Affected builds",
	["Berserker_Help_mod_active_desc"] = "Decides which builds the mod affects: All - Every Build; Berserker - Builds with at least Berserker Basic; Berserker Ace - Builds with Berserker Ace",
	["Berserker_Help_mod_active_1"] = "All",
	["Berserker_Help_mod_active_2"] = "Berserker",
	["Berserker_Help_mod_active_3"] = "Berserker Ace",
	["Berserker_Help_mod_fixed_title"] = "Fixed max health",
	["Berserker_Help_mod_fixed_desc"] = "Sets the maximum health to revive multiplier, not unlike frenzy. But unlike frenzy doesn't give other effects."
})
	local to_add = {}
	for k, v in pairs(Berserker_Help_mod.available_mult) do
		to_add["Berserker_Help_mod_" .. k .. "mult"] = v
	end
	LocalizationManager:add_localized_strings(to_add)
end)

----------------------------------------------- Menu ------------------------------------------------------



Hooks:Add("MenuManagerInitialize", "MenuManagerInitialize_Berserker_Help_mod", function(menu_manager)

	MenuCallbackHandler.Berserker_Help_mod_mult_callback  = function(this,item)
		Berserker_Help_mod._settings.multiplier = item:value()
		Berserker_Help_mod:AdjustFixed()
	end

	MenuCallbackHandler.Berserker_Help_mod_active_callback  = function(this,item)
		Berserker_Help_mod._settings.active = item:value()
		Berserker_Help_mod:AdjustFixed()
	end

	MenuCallbackHandler.Berserker_Help_mod_fixed_callback  = function(this,item)
		Berserker_Help_mod._settings.fixed = Utils:ToggleItemToBoolean(item)
		Berserker_Help_mod:AdjustFixed()
	end
	
	MenuCallbackHandler.Berserker_Help_mod_combat_cancer_callback = function(this,item)
		Berserker_Help_mod._settings.combat_cancer = Utils:ToggleItemToBoolean(item)
	end

	MenuCallbackHandler.Berserker_Help_mod_back = function(this, item)
		Berserker_Help_mod:Save()
	end
	
	Berserker_Help_mod:Load()
	-- Main Menu
	Hooks:Add("MenuManagerSetupCustomMenus", "Base_SetupCustomMenus_Json_Berserker_Help_mod_main_menu", function( menu_manager, nodes )
			MenuHelper:NewMenu( "Berserker_Help_mod_main_menu" )
		end)

	Hooks:Add("MenuManagerBuildCustomMenus", "Base_BuildCustomMenus_Json_Berserker_Help_mod_main_menu", function( menu_manager, nodes )

			local parent_menu = "blt_options"
			local menu_id = "Berserker_Help_mod_main_menu"
			local menu_name = "Berserker_Help_mod_main_menu_title"
			local menu_desc = "Berserker_Help_mod_main_menu_desc"

			local data = {
				focus_changed_callback = nil,
				back_callback = "Berserker_Help_mod_back",
				area_bg = nil,
			}
			nodes[menu_id] = MenuHelper:BuildMenu( menu_id, data )

			MenuHelper:AddMenuItem( nodes[parent_menu], menu_id, menu_name, menu_desc, nil )

		end)

	Hooks:Add("MenuManagerPopulateCustomMenus", "Base_PopulateCustomMenus_Json_Berserker_Help_mod_main_menu", function( menu_manager, nodes )

			local to_add = {"Berserker_Help_mod_active_1" , "Berserker_Help_mod_active_2", "Berserker_Help_mod_active_3"}
			MenuHelper:AddMultipleChoice({
				id = "Berserker_Help_mod_active",
				title = "Berserker_Help_mod_active_title",
				desc = "Berserker_Help_mod_active_desc",
				callback = "Berserker_Help_mod_active_callback",
				items = to_add,
				value = Berserker_Help_mod._settings.active,
				menu_id = "Berserker_Help_mod_main_menu",
				priority = 4,
			})

			MenuHelper:AddDivider({
				id = "Berserker_Help_mod_divider",
				size = 24,
				menu_id = "Berserker_Help_mod_main_menu",
				priority = 3,
			})

			MenuHelper:AddToggle({
				id = "Berserker_Help_mod_combat_cancer",
				title = "Berserker_Help_mod_combat_cancer_title",
				desc = "Berserker_Help_mod_combat_cancer_desc",
				callback = "Berserker_Help_mod_combat_cancer_callback",
				value = Berserker_Help_mod._settings.combat_cancer,
				menu_id = "Berserker_Help_mod_main_menu",
				priority = 2,
				localized = true,
			})


			to_add = {}
			for k, _ in pairs(Berserker_Help_mod.available_mult) do
				table.insert(to_add,"Berserker_Help_mod_" .. k .. "mult")
			end
			MenuHelper:AddMultipleChoice({
				id = "Berserker_Help_mod_mult",
				title = "Berserker_Help_mod_mult_title",
				desc = "Berserker_Help_mod_mult_desc",
				callback = "Berserker_Help_mod_mult_callback",
				items = to_add,
				value = Berserker_Help_mod._settings.multiplier,
				menu_id = "Berserker_Help_mod_main_menu",
				priority = 1,
			})
			MenuHelper:AddToggle({
				id = "Berserker_Help_mod_fixed",
				title = "Berserker_Help_mod_fixed_title",
				desc = "Berserker_Help_mod_fixed_desc",
				callback = "Berserker_Help_mod_fixed_callback",
				value = Berserker_Help_mod._settings.fixed,
				menu_id = "Berserker_Help_mod_main_menu",
				priority = 0,
				localized = true,
			})

		end)
	
end)
